import java.util.*;


class Mediat{

    private Document[] t;

    public Mediat(){
	t = new Document[0];
    }

    private static void ajoutDocTab(Document d,Document[] ancien,Document[] nouveau ){
	for(int i=0;i<ancien.length;i++){
	    nouveau[i]=ancien[i];
	}
	nouveau[nouveau.length-1]=d;
    }

    public void addDocument(Document d){
	Document[] nouv = new Document[this.t.length+1];
	Mediat.ajoutDocTab(d,this.t,nouv);
	this.t = nouv;
    }
    

    private int nombreDocs(){
	return this.t.length;
    }

    public String toString(){
	String res = "";
	for(int i=0;i<t.length;i++){
	    res = res + this.t[i].toString() + "\n";
	}    
	return res;
    }


    public boolean emprunter(int i){
	//aucune vérification sur i!
	return this.t[i].emprunter();
    }


    public Livre[] rechercheLivres(String auteur){
	Livre[] res = new Livre[0];
	for(int i=0;i<this.nombreDocs();i++){
	//nombreDocs() est plus propre que this.t.length!
	    if(this.t[i].getType().equals("Livre")){
		//comparer avec "Livre" n'est pas beau, il faudrait au moins faire des chaines "constantes" (ou une "énum")
		//le cast suivant n'est pas dangereux puisque l'on vient de vérifier que t[i] est bien un livre
		//mais on évitera le cast le plus possble

		if(((Livre)(this.t[i])).verifAuteur(auteur)){
		    //il est plus propre d'envoyer la chaine auteur au Livre afin qui lui vérifie, 
		    //plutôt que de "décortiquer" un livre avec des méthodes getAuteur(), getxxx()
		    
		    Livre[] nouv = new Livre[res.length+1];
		    Mediat.ajoutDocTab(this.t[i],res,nouv);
		    //remarquez la syntaxe pour appeler une méthode statique de la classe
		    //remarquez SURTOUT L'INTERET DU POLYMORPHISME : 
		    //la méthode ajoutDocTab prend en paramètres des tableaux de documents
		    //ainsi, on pourra l'utiliser pour les livres ou les cds!
		   
		    res = nouv;
		}
	    }
	}
	return res;
    }


    public static void main(String[] args){
	System.out.println("hello");
	Mediat m = new Mediat();
	Livre l1 = new Livre(1,"Titre Livre1","Auteur a",true);
	Livre l2 = new Livre(2,"Titre Livre2","Auteur b",true);
	Livre l3 = new Livre(3,"Titre Livre3","Auteur a",true);
	Cd cd1 = new Cd (1,"Titre cd1", "Interprete1", 
			 "Compositeur1", true);
	m.addDocument(l1);
	m.addDocument(l2);
	m.addDocument(l3);
	m.addDocument(cd1);
	System.out.println(m.toString());

	m.emprunter(0);// on ne récupère pas le résultat
	System.out.println(m.toString());

	cd1.emprunter();// test : si on modifie un des documents de 
	//la médiathèque "directement", cela se répercute bien sur la médiathèque! (danger..)
	System.out.println(m.toString());//ici on voit que le cd1 est emprunté

	Livre[] res = m.rechercheLivres("Auteur a");
	System.out.println("resultat de la recherche");
	for(int i=0;i<res.length;i++){
	    System.out.println(res[i].toString());
	}

    }
}


//discussion sur le "comment pas caster", on oublie..

    // main 
    // InfoLivre i1 = new InfoLivre(String auteur);
    // InfoCd i2 = new InfoCd(String compo, String style);
    // t[i].verifInfo(i1 ou i2);

    // Document
    // verifInfo(Information i){
    // 	-serra abstract :) return false;
    // }

    // Livre
    // 	verifInfo(INformation i) (et surtout pas info livre)
    // InfoLivre extends Info
    // InfoCd extends Info
